function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useMemo } from 'react';
import { VirtualKeyboard } from '@pisell/materials';
import Delete from '@pisell/icon/es/Delete';
import { locales } from '@pisell/utils';
import useEngineContext from "../../hooks/useEngineContext";
import localeTexts from "./locales";
import "./index.less";
var NumberKeyboard = function NumberKeyboard(props) {
  var _context$engine;
  var context = useEngineContext();
  locales.init(localeTexts, (context === null || context === void 0 || (_context$engine = context.engine) === null || _context$engine === void 0 || (_context$engine = _context$engine.props) === null || _context$engine === void 0 ? void 0 : _context$engine.locale) || 'en');
  var _useState = useState((props === null || props === void 0 ? void 0 : props.value) || ''),
    _useState2 = _slicedToArray(_useState, 2),
    num = _useState2[0],
    setNum = _useState2[1];
  var KeyboardItems = useMemo(function () {
    return [{
      value: 1,
      label: '1',
      disabled: false,
      type: 'text'
    }, {
      value: 2,
      label: '2',
      disabled: false,
      type: 'text'
    }, {
      value: 3,
      label: '3',
      disabled: false,
      type: 'text'
    }, {
      value: 4,
      label: '4',
      disabled: false,
      type: 'text'
    }, {
      value: 5,
      label: '5',
      disabled: false,
      type: 'text'
    }, {
      value: 6,
      label: '6',
      disabled: false,
      type: 'text'
    }, {
      value: 7,
      label: '7',
      disabled: false,
      type: 'text'
    }, {
      value: 8,
      label: '8',
      disabled: false,
      type: 'text'
    }, {
      value: 9,
      label: '9',
      disabled: false,
      type: 'text'
    }, {
      value: 'delete',
      label: (props === null || props === void 0 ? void 0 : props.deleteText) || /*#__PURE__*/React.createElement(Delete, {
        className: "virtual-keyboard-input-delete-icon-num"
      }),
      disabled: false,
      type: 'text'
    }, {
      value: 0,
      label: '0',
      disabled: false,
      type: 'text'
    }, {
      value: 'ok',
      label: (props === null || props === void 0 ? void 0 : props.okText) || locales.getText('pisell2.number.keyboard.ok'),
      disabled: false,
      type: 'primary'
    }];
  }, [locales, props === null || props === void 0 ? void 0 : props.okText, props === null || props === void 0 ? void 0 : props.deleteText]);
  var handleKeyboardChange = function handleKeyboardChange(e) {
    if (e === 'ok') {
      var _props$onOk;
      props === null || props === void 0 || (_props$onOk = props.onOk) === null || _props$onOk === void 0 || _props$onOk.call(props);
    } else if (e === 'delete') {
      var _props$onDelete;
      if (num.length === 0) {
        return;
      }
      var newNum = num.slice(0, -1);
      setNum(newNum);
      props === null || props === void 0 || (_props$onDelete = props.onDelete) === null || _props$onDelete === void 0 || _props$onDelete.call(props, newNum);
    } else {
      var _props$onChange;
      // 如果输入框的最大长度大于0，则限制输入框的长度
      if (props !== null && props !== void 0 && props.maxLength && num.length >= (props === null || props === void 0 ? void 0 : props.maxLength)) {
        console.log('input_maxLength_over', props === null || props === void 0 ? void 0 : props.maxLength, num);
        return;
      }
      var _newNum = num + e;

      // 检查最大值限制
      if (props !== null && props !== void 0 && props.max && parseInt(_newNum) > props.max) {
        console.log('input_maxValue_over', props === null || props === void 0 ? void 0 : props.max, _newNum);
        return;
      }
      setNum(_newNum);
      props === null || props === void 0 || (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, _newNum);
    }
  };
  var handleInputChange = function handleInputChange(e) {
    var _props$onChange2;
    var newNum = e.target.value;

    // 检查最大值限制
    if (props !== null && props !== void 0 && props.max && parseInt(newNum) > props.max) {
      return;
    }
    setNum(newNum);
    props === null || props === void 0 || (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 || _props$onChange2.call(props, newNum);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "pisell-pro-number-keyboard"
  }, /*#__PURE__*/React.createElement(VirtualKeyboard, {
    style: _objectSpread({}, (props === null || props === void 0 ? void 0 : props.style) || {}),
    selectType: "dark",
    keyboardProps: {
      keydown: false,
      items: KeyboardItems,
      onChange: handleKeyboardChange
    },
    virtualKeyInputProps: {
      value: num,
      onChange: handleInputChange,
      placeholder: (props === null || props === void 0 ? void 0 : props.placeholder) || '',
      style: _objectSpread({
        height: '65px',
        fontSize: '36px'
      }, (props === null || props === void 0 ? void 0 : props.inputStyle) || {})
    }
  }));
};
export default NumberKeyboard;